precision highp float;

varying vec2 textureCoordinate;

uniform sampler2D iChannel0;

uniform float iTime;
uniform float intensity;
uniform float rand;

//2D (returns 0 - 1)
float random2d(vec2 n) {
    return fract(sin(dot(n, vec2(12.9898, 4.1414))) * 43758.5453);
}

float randomRange (in vec2 seed, in float min, in float max) {
    return min + random2d(seed) * (max - min);
}

// return 1 if v inside 1d range
float insideRange(float v, float bottom, float top) {
    return step(bottom, v) - step(top, v);
}

void main() {

    float AMT = 0.01;//0 - 1 glitch amount
    float SPEED = 0.1;//0 - 1 speed
    float time = floor(iTime * SPEED * 60.0);
    vec2 uv = textureCoordinate;

    vec3 outCol = texture2D(iChannel0, uv).rgb;

    float maxOffset = 0.3;
    for (float i = 0.0; i < 10.0 * AMT; i += 1.0) {
        float sliceY = rand;// random2d(vec2(time, 2345.0 + float(i)));
        float sliceH = random2d(vec2(time, 9035.0 + float(i))) * 0.25;
        float hOffset = randomRange(vec2(time, 9625.0 + float(i)), -maxOffset, maxOffset);
        vec2 uvOff = uv;
        uvOff.x += hOffset;
        if (insideRange(uv.y, sliceY, fract(sliceY+sliceH)) == 1.0){
            outCol = texture2D(iChannel0, uvOff).rgb;
        }
    }

    float maxColOffset = 0.005;
    float rnd = random2d(vec2(time, 9545.0));
    vec2 colOffset = vec2(randomRange(vec2(time, 9545.0), -maxColOffset, maxColOffset), randomRange(vec2(time, 7205.0), -maxColOffset, maxColOffset));

    if (rnd < 0.33){
        outCol.r = texture2D(iChannel0, uv + colOffset).r;

    } else if (rnd < 0.66){
        outCol.g = texture2D(iChannel0, uv + colOffset).g;

    } else {
        outCol.b = texture2D(iChannel0, uv + colOffset).b;
    }

    gl_FragColor = vec4(outCol, 1.0);
    vec4 texori = texture2D(iChannel0, uv);
    gl_FragColor = vec4(texori.rgb*(1.0 - intensity) + gl_FragColor.rgb * intensity, 1.);
}
